package cz.jzitnik.game.sprites;

import cz.jzitnik.tui.ResourceLoader;
import cz.jzitnik.tui.Sprite;

import java.util.Optional;

public class Pig extends Sprite {
    public enum PigState{
        LEFT,
        RIGHT,
        LEFT_HURT,
        RIGHT_HURT
    }

    public String getSprite() {
        return getSprite(PigState.RIGHT);
    }

    public String getSprite(Enum e) {
        return ResourceLoader.loadResource(
                switch (e) {
                    case PigState.LEFT -> "mobs/pig/left.ans";
                    case PigState.RIGHT -> "mobs/pig/right.ans";
                    case PigState.LEFT_HURT -> "mobs/pig/lefthurt.ans";
                    case PigState.RIGHT_HURT -> "mobs/pig/righthurt.ans";
                    default -> throw new IllegalStateException("Unexpected value: " + e);
                }
        );
    }

    @Override
    public Optional<Class<PigState>> getStates() {
        return Optional.of(PigState.class);
    }
}
