package cz.jzitnik.game.sprites;

import cz.jzitnik.tui.ResourceLoader;
import cz.jzitnik.tui.Sprite;

import java.util.Optional;

public class Wool extends Sprite {
    public enum WoolState {
        WHITE,
        LIGHT_GRAY,
        GRAY,
        BLACK,
        BROWN,
        PINK,
    }

    public String getSprite() {
        return getSprite(WoolState.WHITE);
    }

    public String getSprite(Enum e) {
        return ResourceLoader.loadResource(
                switch (e) {
                    case WoolState.WHITE -> "white_wool.ans";
                    case WoolState.LIGHT_GRAY -> "light_gray_wool.ans";
                    case WoolState.GRAY -> "gray_wool.ans";
                    case WoolState.BLACK -> "black_wool.ans";
                    case WoolState.BROWN -> "brown_wool.ans";
                    case WoolState.PINK -> "pink_wool.ans";

                    default -> throw new IllegalStateException("Unexpected value: " + e);
                }
        );
    }

    @Override
    public Optional<Class<WoolState>> getStates() {
        return Optional.of(WoolState.class);
    }
}
