package cz.jzitnik.game.sprites;

import cz.jzitnik.tui.ResourceLoader;
import cz.jzitnik.tui.Sprite;

import java.util.Optional;

public class WoolItem extends Sprite {
    public enum WoolItemState {
        WHITE,
        LIGHT_GRAY,
        GRAY,
        BLACK,
        BROWN,
        PINK,
    }

    public String getSprite() {
        return getSprite(WoolItemState.WHITE);
    }

    public String getSprite(Enum e) {
        return ResourceLoader.loadResource(
                switch (e) {
                    case WoolItemState.WHITE -> "items/white_wool.ans";
                    case WoolItemState.LIGHT_GRAY -> "items/light_gray_wool.ans";
                    case WoolItemState.GRAY -> "items/gray_wool.ans";
                    case WoolItemState.BLACK -> "items/black_wool.ans";
                    case WoolItemState.BROWN -> "items/brown_wool.ans";
                    case WoolItemState.PINK -> "items/pink_wool.ans";

                    default -> throw new IllegalStateException("Unexpected value: " + e);
                }
        );
    }

    @Override
    public Optional<Class<WoolItemState>> getStates() {
        return Optional.of(WoolItemState.class);
    }
}
